Codeforces Round 938 (Div. 3)H-The Most Reckless Defense (状压dp)

2024-05-03 14:44

本文主要是介绍Codeforces Round 938 (Div. 3)H-The Most Reckless Defense (状压dp),希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

来源

题目

You are playing a very popular Tower Defense game called "Runnerfield 2". In this game, the player sets up defensive towers that attack enemies moving from a certain starting point to the player's base.

You are given a grid of size n×m𝑛×𝑚, on which k𝑘 towers are already placed and a path is laid out through which enemies will move. The cell at the intersection of the x𝑥-th row and the y𝑦-th column is denoted as (x,y)(𝑥,𝑦).

Each second, a tower deals pi𝑝𝑖 units of damage to all enemies within its range. For example, if an enemy is located at cell (x,y)(𝑥,𝑦) and a tower is at (xi,yi)(𝑥𝑖,𝑦𝑖) with a range of r𝑟, then the enemy will take damage of pi𝑝𝑖 if (x−xi)2+(y−yi)2≤r2(𝑥−𝑥𝑖)2+(𝑦−𝑦𝑖)2≤𝑟2.

Enemies move from cell (1,1)(1,1) to cell (n,m)(𝑛,𝑚), visiting each cell of the path exactly once. An enemy instantly moves to an adjacent cell horizontally or vertically, but before doing so, it spends one second in the current cell. If its health becomes zero or less during this second, the enemy can no longer move. The player loses if an enemy reaches cell (n,m)(𝑛,𝑚) and can make one more move.

By default, all towers have a zero range, but the player can set a tower's range to an integer r𝑟 (r>0𝑟>0), in which case the health of all enemies will increase by 3r3𝑟. However, each r𝑟 can only be used for at most one tower.

Suppose an enemy has a base health of hℎ units. If the tower ranges are 22, 44, and 55, then the enemy's health at the start of the path will be h+32+34+35=h+9+81+243=h+333ℎ+32+34+35=ℎ+9+81+243=ℎ+333. The choice of ranges is made once before the appearance of enemies and cannot be changed after the game starts.

Find the maximum amount of base health hℎ for which it is possible to set the ranges so that the player does not lose when an enemy with health hℎ passes through (without considering the additions for tower ranges).

Input

The first line contains an integer t𝑡 (1≤t≤1001≤𝑡≤100) — the number of test cases.

The first line of each test case contains three integers n𝑛, m𝑚, and k𝑘 (2≤n,m≤50,1≤k<n⋅m2≤𝑛,𝑚≤50,1≤𝑘<𝑛⋅𝑚) — the dimensions of the field and the number of towers on it.

The next n𝑛 lines each contain m𝑚 characters — the description of each row of the field, where the character "." denotes an empty cell, and the character "#" denotes a path cell that the enemies will pass through.

Then follow k𝑘 lines — the description of the towers. Each line of description contains three integers xi𝑥𝑖, yi𝑦𝑖, and pi𝑝𝑖 (1≤xi≤n,1≤yi≤m,1≤pi≤5001≤𝑥𝑖≤𝑛,1≤𝑦𝑖≤𝑚,1≤𝑝𝑖≤500) — the coordinates of the tower and its attack parameter. All coordinates correspond to empty cells on the game field, and all pairs (xi,yi)(𝑥𝑖,𝑦𝑖) are pairwise distinct.

It is guaranteed that the sum of n⋅m𝑛⋅𝑚 does not exceed 25002500 for all test cases.

Output

For each test case, output the maximum amount of base health hℎ on a separate line, for which it is possible to set the ranges so that the player does not lose when an enemy with health hℎ passes through (without considering the additions for tower ranges).

If it is impossible to choose ranges even for an enemy with 11 unit of base health, output "0".

题意

有n*m的格子,“#”是敌人会经过的位置,有k个防御装置,有对应的位置和攻击力,对于每个防御装置,每增加r的攻击半径,怪物就会增加3^{r}点生命,问最多能防御多少点生命的怪物。

思路

       首先,可以发现r的取值不能很大,怪物的血量呈指数上升,稍微打一下表可以发现,r大于13的话就不可能杀死了。

       其次,一个防御建筑的有效攻击应该是,它能覆盖到的格子数*它的攻击力-它给怪物增加的血量。

       所以现在的问题就变成了,每个防御装置可以选择0-13半径的攻击范围,问最多能产生多少的有效攻击。因为半径的选择范围很小,可以用这一点进行状压dp

       首先可以先对每个防御塔,在不同的半径下能产生的有效伤害预处理。

bool check(int x,int y,int p,int q,int r){return (x-p)*(x-p)+(y-q)*(y-q)<=r*r;
}
 
for(int i=1;i<=k;i++){int x,y,w;cin>>x>>y>>w;for(int j=0;j<=13;j++){b[i][j]=0;for(int p=1;p<=n;p++){for(int q=1;q<=m;q++){if(a[p][q]=='.')continue;if(check(x,y,p,q,j))b[i][j]+=w;;}}}}

       定义dp[i][j]为前i个防御塔,用了j状态的半径(二进制的14位表示0-13是否使用),能产生的最多的有效攻击。

转移较为简单

for(int i=1;i<=k;i++){for(int j=0;j<(1<<14);j++){dp[i][j]=dp[i-1][j]+b[i][0];for(int p=1;p<=13;p++){if((j>>p)&1){dp[i][j]=max(dp[i][j],dp[i-1][j^(1<<p)]+b[i][p]);}}}}

最后比较每一种状态

#include <bits/stdc++.h>
using namespace std;
#define int long longchar a[55][55];
int dp[3000][1<<13];
int b[10000][20];bool check(int x,int y,int p,int q,int r){return (x-p)*(x-p)+(y-q)*(y-q)<=r*r;
}void solve(){int n,m,k;cin>>n>>m>>k;for(int i=1;i<=n;i++){cin>>a[i]+1;}for(int i=1;i<=k;i++){int x,y,w;cin>>x>>y>>w;for(int j=0;j<=13;j++){b[i][j]=0;for(int p=1;p<=n;p++){for(int q=1;q<=m;q++){if(a[p][q]=='.')continue;if(check(x,y,p,q,j))b[i][j]+=w;;}}}}for(int i=1;i<=k;i++){for(int j=0;j<(1<<14);j++){dp[i][j]=dp[i-1][j]+b[i][0];for(int p=1;p<=13;p++){if((j>>p)&1){dp[i][j]=max(dp[i][j],dp[i-1][j^(1<<p)]+b[i][p]);}}}}int ans=0;for(int i=0;i<(1<<14);i++){int res=dp[k][i];int p=1;for(int j=1;j<=13;j++){p*=3;if((i>>j)&1)res-=p;}ans=max(ans,res);} cout<<ans<<'\n';
}
signed main(){ios::sync_with_stdio(false);cin.tie(0);cout.tie(0);int t=1;cin>>t;while(t--)solve();return 0;
}

这篇关于Codeforces Round 938 (Div. 3)H-The Most Reckless Defense (状压dp)的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/956988

相关文章

hdu4826(三维DP)

这是一个百度之星的资格赛第四题 题目链接:http://acm.hdu.edu.cn/contests/contest_showproblem.php?pid=1004&cid=500 题意:从左上角的点到右上角的点,每个点只能走一遍,走的方向有三个:向上,向下,向右,求最大值。 咋一看像搜索题,先暴搜,TLE,然后剪枝,还是TLE.然后我就改方法,用DP来做,这题和普通dp相比,多个个向上

hdu1011(背包树形DP)

没有完全理解这题, m个人,攻打一个map,map的入口是1,在攻打某个结点之前要先攻打其他一个结点 dp[i][j]表示m个人攻打以第i个结点为根节点的子树得到的最优解 状态转移dp[i][ j ] = max(dp[i][j], dp[i][k]+dp[t][j-k]),其中t是i结点的子节点 代码如下: #include<iostream>#include<algorithm

hdu4865(概率DP)

题意:已知前一天和今天的天气概率,某天的天气概率和叶子的潮湿程度的概率,n天叶子的湿度,求n天最有可能的天气情况。 思路:概率DP,dp[i][j]表示第i天天气为j的概率,状态转移如下:dp[i][j] = max(dp[i][j, dp[i-1][k]*table2[k][j]*table1[j][col] )  代码如下: #include <stdio.h>#include

usaco 1.1 Broken Necklace(DP)

直接上代码 接触的第一道dp ps.大概的思路就是 先从左往右用一个数组在每个点记下蓝或黑的个数 再从右到左算一遍 最后取出最大的即可 核心语句在于: 如果 str[i] = 'r'  ,   rl[i]=rl[i-1]+1, bl[i]=0 如果 str[i] = 'b' ,  bl[i]=bl[i-1]+1, rl[i]=0 如果 str[i] = 'w',  bl[i]=b

uva 10154 DP 叠乌龟

题意: 给你几只乌龟,每只乌龟有自身的重量和力量。 每只乌龟的力量可以承受自身体重和在其上的几只乌龟的体重和内。 问最多能叠放几只乌龟。 解析: 先将乌龟按力量从小到大排列。 然后dp的时候从前往后叠,状态转移方程: dp[i][j] = dp[i - 1][j];if (dp[i - 1][j - 1] != inf && dp[i - 1][j - 1] <= t[i]

uva 10118 dP

题意: 给4列篮子,每次从某一列开始无放回拿蜡烛放入篮子里,并且篮子最多只能放5支蜡烛,数字代表蜡烛的颜色。 当拿出当前颜色的蜡烛在篮子里存在时,猪脚可以把蜡烛带回家。 问最多拿多少只蜡烛。 代码: #include <iostream>#include <cstdio>#include <cstdlib>#include <algorithm>#include <cs

uva 10069 DP + 大数加法

代码: #include <iostream>#include <cstdio>#include <cstdlib>#include <algorithm>#include <cstring>#include <cmath>#include <stack>#include <vector>#include <queue>#include <map>#include <cl

uva 10029 HASH + DP

题意: 给一个字典,里面有好多单词。单词可以由增加、删除、变换,变成另一个单词,问能变换的最长单词长度。 解析: HASH+dp 代码: #include <iostream>#include <cstdio>#include <cstdlib>#include <algorithm>#include <cstring>#include <cmath>#inc

XTU 1233 n个硬币连续m个正面个数(dp)

题面: Coins Problem Description: Duoxida buys a bottle of MaiDong from a vending machine and the machine give her n coins back. She places them in a line randomly showing head face or tail face o

dp算法练习题【8】

不同二叉搜索树 96. 不同的二叉搜索树 给你一个整数 n ,求恰由 n 个节点组成且节点值从 1 到 n 互不相同的 二叉搜索树 有多少种?返回满足题意的二叉搜索树的种数。 示例 1: 输入:n = 3输出:5 示例 2: 输入:n = 1输出:1 class Solution {public int numTrees(int n) {int[] dp = new int